package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;
import box2D.collision.shapes.B2Shape;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_26_26_StartScene3D extends SceneScript
{
	public var _theList:Array<Dynamic>;
	public var _theStep:Float;
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_3dText():Void
	{
		engine.allActors.reuseIterator = false;
		for(actorOnScreen in engine.allActors)
		{
			if(actorOnScreen != null && !actorOnScreen.dead && !actorOnScreen.recycled && actorOnScreen.isOnScreenCache)
			{
				actorOnScreen.growTo(0/100, 0/100, 0, Easing.linear);
				actorOnScreen.growTo(100/100, 100/100, 6, Easing.linear);
			}
		}
		engine.allActors.reuseIterator = true;
		A3D.stencyl(Engine.engine);ResourceLoader.loadResource("three","FILE", "assets/data/three.obj", function myLoadFunc(){_theList = new Array<Dynamic>();
			_theList.push(A3D.getObject("three"));
			A3D.stencyl(Engine.engine);A3D.callMethod("Scene0","addChild",_theList);
			A3D.stencyl(Engine.engine);A3D.setProperty("three","y",-600);
			A3D.stencyl(Engine.engine);A3D.createObjectArgs("color","ColorMaterial",new Array<Dynamic>());
			/* green color */
			A3D.stencyl(Engine.engine);A3D.setProperty("color","color",Utils.getColorRGB(0,200,50));
			A3D.stencyl(Engine.engine);A3D.setProperty("color","lightPicker",A3D.getObject("Picker0"));
			A3D.stencyl(Engine.engine);A3D.setProperty("three","material",A3D.getObject("color"));
			_customEvent_scaleThree();
			setGameAttribute("isDone", true);
			A3D.stencyl(Engine.engine);A3D.setProperty("three","rotationX",180);});
	}
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_scaleThree():Void
	{
		A3D.stencyl(Engine.engine);A3D.setProperty("three","scaleX",-6);
		A3D.stencyl(Engine.engine);A3D.setProperty("three","scaleY",-6);
		A3D.stencyl(Engine.engine);A3D.setProperty("three","scaleZ",-6);
	}
	
	
	public function new(dummy:Int, dummy2:Engine)
	{
		super();
		nameMap.set("theList", "_theList");
		nameMap.set("theStep", "_theStep");
		_theStep = 0.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		createRecycledActor(getActorType(23), 77, 58, Script.FRONT);
		getLastCreatedActor().growTo(0/100, 0/100, 0, Easing.linear);
		createRecycledActor(getActorType(21), 193, 258, Script.FRONT);
		getLastCreatedActor().growTo(0/100, 0/100, 0, Easing.linear);
		setGameAttribute("isDone", false);
		
		/* ======================= After N seconds ======================== */
		runLater(1000 * 1, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				_customEvent_3dText();
			}
		}, null);
		
		/* ======================= Every N seconds ======================== */
		runPeriodically(1000 * 0.05, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				setGameAttribute("growSize", 1);
				if(((getGameAttribute("isDone")) : Bool))
				{
					A3D.stencyl(Engine.engine);A3D.setProperty("three","rotationY",(asNumber(A3D.getProperty("three","rotationY")) + 1));
				}
			}
		}, null);
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}