package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;
import box2D.collision.shapes.B2Shape;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_29_29_changeTiles extends SceneScript
{
	public var _theList:Array<Dynamic>;
	public var _theList2:Array<Dynamic>;
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_TextureMap():Void
	{
		/* Textures from:  https://3dtextures.me */
		A3D.stencyl(Engine.engine);ResourceLoader.loadResource("Normal","FILE", "assets/data/Stone_Wall_007_NORM.jpg", function myLoadFunc(){A3D.stencyl(Engine.engine);ResourceLoader.loadResource("Diffuse","FILE", "assets/data/Stone_Wall_007_COLOR.jpg", function myLoadFunc(){A3D.stencyl(Engine.engine);ResourceLoader.loadResource("Specular","FILE", "assets/data/Stone_Wall_007_DISP.png", function myLoadFunc(){A3D.stencyl(Engine.engine);A3D.createObjectArgs("tileMaterial","TextureMaterial",new Array<Dynamic>());
					A3D.stencyl(Engine.engine);A3D.setProperty("tileMaterial","texture",A3D.getObject("Diffuse"));
					A3D.stencyl(Engine.engine);A3D.setProperty("tileMaterial","specularMap",A3D.getObject("Specular"));
					A3D.stencyl(Engine.engine);A3D.setProperty("tileMaterial","normalMap",A3D.getObject("Normal"));});});});
	}
	
	
	public function new(dummy:Int, dummy2:Engine)
	{
		super();
		nameMap.set("theList", "_theList");
		nameMap.set("theList2", "_theList2");
		
	}
	
	override public function init()
	{
		
		/* ======================= After N seconds ======================== */
		runLater(1000 * 1.2, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				A3D.stencyl(Engine.engine);A3D.createObjectArgs("Tile0","Mesh",new Array<Dynamic>());
				A3D.stencyl(Engine.engine);A3D.createObjectArgs("theGeo","CubeGeometry",new Array<Dynamic>());
				A3D.stencyl(Engine.engine);A3D.setProperty("theGeo","width",100);
				_theList = new Array<Dynamic>();
				_theList.push(Utils.getColorRGB(100,100,100));
				A3D.stencyl(Engine.engine);A3D.createObjectArgs("Tile0","Mesh",new Array<Dynamic>());
				A3D.stencyl(Engine.engine);A3D.setProperty("Tile0","geometry",A3D.getObject("theGeo"));
				/* tileMaterial is loaded in TextureMap EventTrigger */
				A3D.stencyl(Engine.engine);A3D.setProperty("Tile0","material",A3D.getObject("tileMaterial"));
				/* "Change all Tiles in TileSetID 4 with the Tile0 Mesh  ... TileSetID : get it from the tile editor" */ A3D.stencyl(Engine.engine);Bind.Tile(4,0,"Tile0"); 
				A3D.stencyl(Engine.engine);A3D.setProperty("Stencyl","HideTileSetID",4);
				/* 
Get the lightpicker from the last player */
				for(actorOfType in getActorsOfType(getActorType(17)))
				{
					if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
						A3D.stencyl(Engine.engine);A3D.setProperty("tileMaterial","lightPicker",A3D.getObject((("Picker") + ("" + actorOfType.getActorValue("Part")))));
					}
				}
			}
		}, null);
		
		/* ======================= After N seconds ======================== */
		runLater(1000 * 0.1, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				_customEvent_TextureMap();
			}
		}, null);
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}