package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_2_2_StartActorBehavior extends ActorScript
{
	public var _Part:Float;
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("Part", "_Part");
		_Part = 0.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		actor.setActorValue("Part", _Part);
		actor.setActorValue("NrActors", 0);
		actor.setActorValue("MaxActors", 5);
		actor.setActorValue("TotalActors", 0);
		
		/* ======================= Every N seconds ======================== */
		runPeriodically(1000 * 1, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				actor.setActorValue("totalActors", 0);
				for(actorOfType in getActorsOfType(getActorType(2)))
				{
					if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
						if((actor.getActorValue("Part") == _Part))
						{
							actor.setActorValue("totalActors", (asNumber(actor.getActorValue("totalActors")) + 1));
						}
					}
				}
				if(((asNumber(actor.getActorValue("MaxActors")) > 0) && (asNumber(actor.getActorValue("totalActors")) < asNumber((getGameAttribute("MaxActors"))))))
				{
					createRecycledActor(getActorType(2), actor.getX(), actor.getY(), Script.FRONT);
					actor.setActorValue("NrActors", (asNumber(actor.getActorValue("NrActors")) + 1));
					getLastCreatedActor().setActorValue("Part", _Part);
					shoutToScene("_customEvent_" + "findNewBall");
				}
				actor.setAnimation("" + actor.getActorValue("MaxActors"));
			}
		}, actor);
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}