package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;
import box2D.collision.shapes.B2Shape;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_4_4_SceneBehavior extends SceneScript
{
	
	
	public function new(dummy:Int, dummy2:Engine)
	{
		super();
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		setGameAttribute("MaxActors", 4);
		setGameAttribute("removeList", new Array<Dynamic>());
		
		/* ======================= Every N seconds ======================== */
		runPeriodically(1000 * 1, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				for(actorOfType in getActorsOfType(getActorType(0)))
				{
					if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
						if((asNumber(actorOfType.getActorValue("MaxActors")) < 1))
						{
							setGameAttribute("goAwayPart", actorOfType.getActorValue("Part"));
							((getGameAttribute("removeList")) : Array<Dynamic>).push(actorOfType.getActorValue("Part"));
						}
					}
				}
				engine.allActors.reuseIterator = false;
				for(actorOnScreen in engine.allActors)
				{
					if(actorOnScreen != null && !actorOnScreen.dead && !actorOnScreen.recycled && actorOnScreen.isOnScreenCache)
					{
						if(Utils.contains(((getGameAttribute("removeList")) : Array<Dynamic>), actorOnScreen.getActorValue("Part")))
						{
							actorOnScreen.moveTo(-200, -200, 1, Easing.linear);
							runLater(1000 * 1, function(timeTask:TimedTask):Void
							{
								recycleActor(actorOnScreen);
							}, null);
						}
					}
				}
				engine.allActors.reuseIterator = true;
				setGameAttribute("SceneCounter", 0);
				for(actorOfType in getActorsOfType(getActorType(0)))
				{
					if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
						setGameAttribute("SceneCounter", (asNumber((getGameAttribute("SceneCounter"))) + 1));
					}
				}
				if((asNumber((getGameAttribute("SceneCounter"))) < 1))
				{
					setGameAttribute("Level", (asNumber((getGameAttribute("Level"))) + 1));
					if((asNumber((getGameAttribute("Level"))) > asNumber((getGameAttribute("MaxLevels")))))
					{
						setGameAttribute("Level", 1);
					}
					A3D.remove();
					runLater(1000 * 0.5, function(timeTask:TimedTask):Void
					{
						switchScene(GameModel.get().scenes.get(getIDForScene((("Level") + ("" + (getGameAttribute("Level")))))).getID(), null, createCrossfadeTransition(0));
					}, null);
				}
			}
		}, null);
		
		/* ======================= Every N seconds ======================== */
		runPeriodically(1000 * 3, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				for(actorOfType in getActorsOfType(getActorType(19)))
				{
					if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
						recycleActor(actorOfType);
					}
				}
			}
		}, null);
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}